-- Author      : Themperror
-- Create Date : 19/02/2017 01:44:38 PM

local frame = CreateFrame("FRAME");
frame:RegisterEvent("UPDATE_MOUSEOVER_UNIT");
frame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
frame:RegisterEvent("ADDON_LOADED");

UnitKillCountTable = {};
UnitTeamKillCountTable = {};

local TrackingUnits = {};
local AddonLoad = false;
local function eventHandler(self, event, ...)
	if event == "ADDON_LOADED" then
	AddonLoad = true;
	end
	if AddonLoad then
		if event == "UPDATE_MOUSEOVER_UNIT" then
			ChangeMobInfo();
		elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
			CheckUnitInfo(...);
		end
	end
		
end

function ChangeMobInfo()
	local isMob = not(UnitIsPlayer("mouseover") or UnitIsFriend("player","mouseover") or not UnitCanAttack("mouseover","player"))
	if isMob then
		local Uname = UnitName("mouseover");
		local killcount = 0;
		local teamkillcount = 0;
		if UnitKillCountTable[Uname] ~= nil then
			teamkillcount = UnitTeamKillCountTable[Uname];
			killcount = UnitKillCountTable[Uname];
		else
			UnitKillCountTable[Uname] = 0;
			UnitTeamKillCountTable[Uname] = 0;
		end
		GameTooltip:AddLine(string.format("Kills: %i, Party Kills: %i",killcount,teamkillcount));			
	end
	GameTooltip:Show();
end

function CheckUnitInfo(...)
	local _,unitevent,_,srcGUID,srcName,srcFlags,_, unitid ,unitname, unitflags = ...
	local isPlayer = false;
	local isTeamTag = false;
	local isMob = ((bit.band(unitflags, COMBATLOG_OBJECT_TYPE_MASK) == 0x00000800) and (bit.band(unitflags, COMBATLOG_OBJECT_REACTION_MASK) >= 0x00000020))
	
	if (prefix == SWING_DAMAGE or prefix == RANGE_DAMAGE or prefix == SPELL_DAMAGE or prefix == SPELL_PERIODIC_DAMAGE or prefix == SPELL_BUILDING_DAMAGE) then
		isPlayer = (srcGUID == UnitGUID("player"))
		if(UnitInParty(srcName)== true or UnitPlayerOrPetInParty(srcName) == true) then
			isTeamTag = true;
		end
	end;
	if isMob then
		if(TrackingUnits[unitid] ~= 1) then
			if isPlayer == true then
				--print (string.format("added tracked mob: %s",unitname));
				TrackingUnits[unitid] = 1;
			elseif (isTeamTag == true) then
				TrackingUnits[unitid] = 2;
			end
		end
	end
	if unitevent == "UNIT_DIED" then
		if TrackingUnits[unitid] ~= nil then
			--print(string.format("I killed: %s",unitname))
			local Uname = unitname;
			local killcount = 0;
			local teamkillcount = 0;
			if(TrackingUnits[unitid] == 1) then --player killed the mob (atleast tagged it)
				if UnitKillCountTable[Uname] ~= nil then
					killcount = UnitKillCountTable[Uname];
					UnitKillCountTable[Uname] = killcount+1;
				else
					UnitKillCountTable[Uname] = 1;
				end
			elseif(TrackingUnits[unitid] == 2) then --party member killed the mob without player tagging it
				if UnitTeamKillCountTable[Uname] ~= nil then
					teamkillcount = UnitTeamKillCountTable[Uname];
					UnitTeamKillCountTable[Uname] = teamkillcount+1;
				else
					UnitTeamKillCountTable[Uname] = 1;
				end
			end
			TrackingUnits[unitid] = nil;
		end
	end
end

frame:SetScript("OnEvent", eventHandler);